[PATCH openbmc v4 07/10] initfs: update: check individual mtd partitions for mounts
OpenBMC Patches
openbmc-patches at stwcx.xyz
Wed Jun 15 11:40:28 AEST 2016
From: "Milton D. Miller II" <miltonm at us.ibm.com>
Instead of checking for any mtd device, only check mtd devices that are
to be updated. Include child mtd devices when looking for mounted
filesystems.
If this check is suppressed flash updates are suppressed.
This may be useful to check deferred updates.
Signed-off-by: Milton Miller <miltonm at us.ibm.com>
---
.../obmc-phosphor-initfs/files/obmc-update.sh | 46 +++++++++++++++++++---
1 file changed, 41 insertions(+), 5 deletions(-)
diff --git a/meta-phosphor/common/recipes-phosphor/obmc-phosphor-initfs/files/obmc-update.sh b/meta-phosphor/common/recipes-phosphor/obmc-phosphor-initfs/files/obmc-update.sh
index fc47062..09348b6 100755
--- a/meta-phosphor/common/recipes-phosphor/obmc-phosphor-initfs/files/obmc-update.sh
+++ b/meta-phosphor/common/recipes-phosphor/obmc-phosphor-initfs/files/obmc-update.sh
@@ -19,11 +19,34 @@ then
mount -t devtmpfs dev dev
fi
-if grep mtd /proc/mounts
-then
- echo 1>&2 "Error: A mtd device is mounted."
- exit 1
-fi
+# mtd number N with mtd name Name can be mounted via mtdN, or mtd:Name (with
+# an mtd aware fs) or by /dev/mtdblockN (with a mtd or block fs).
+mtdismounted() {
+ m=${1##mtd}
+ if grep -s "mtdblock$m" /proc/mounts || grep -s "mtd$m" /proc/mounts
+ then
+ return 0
+ fi
+ n=$(cat /sys/class/mtd/mtd$m/name)
+ if test -n "$n" && grep -s "mtd:$n" /proc/mounts
+ then
+ return 0
+ fi
+ return 1
+}
+
+# We need to detect child partitions when the whole flash is to be updated
+# ignore mtdNro and mtdblockN names in the class subsystem directory
+childmtds() {
+ for m in /sys/class/mtd/$1/mtd*
+ do
+ m=${m##*/}
+ if test "${m%ro}" = "${m#mtdblock}"
+ then
+ echo $m
+ fi
+ done
+}
findmtd() {
m=$(grep -xl "$1" /sys/class/mtd/*/name)
@@ -62,6 +85,7 @@ doclean=
dosave=y
dorestore=y
toram=
+checkmount=y
whitelist=/run/initramfs/whitelist
image=/run/initramfs/image-
@@ -90,6 +114,10 @@ do
--no-flash)
doflash=
shift ;;
+ --ignore-mount)
+ checkmount=
+ doflash=
+ shift ;;
--copy-files)
toram=y
shift ;;
@@ -133,6 +161,14 @@ do
echo 1>&2 "Unable to find mtd partiton for ${f##*/}."
exit 1
fi
+ for s in $m $(childmtds $m)
+ do
+ if test -n "$checkmount" && mtdismounted $s
+ then
+ echo 1>&2 "Device $s is mounted, ${f##*/} is busy."
+ exit 1
+ fi
+ done
done
if test -n "$doflash"
--
2.8.4
More information about the openbmc
mailing list